/*
 * Copyright (C) 2009 Castrense Savojardo
 * 	Bologna Biocomputing Group
 * 	University of Bologna, Italy
 *  savojard@biocomp.unibo.it
 * 
 * This file is part of BioCRF
 * 
 * BioCRF is a free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 3 of the License,
 * or (at your option) any later version.
 *
 * BioCRF is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BioCRF; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 * 
 */
#ifndef DOUBLEVECTOR_H_
#define DOUBLEVECTOR_H_
#include <iostream>

namespace mathlib
{

class DoubleVector
{
public:
	
	double *vect;
	int size;
	

	 // default constructor
    DoubleVector() {
	size = 0;
	vect = NULL;
    }

	DoubleVector(int size);
	~DoubleVector()
	{
		//if (vect != NULL)
			delete [] vect;
		
	}
	
	void set(int i, double value);
	double get(int i);
	double sum();
	int max();
	void multiply(double value);
	void multiply(DoubleVector * v);
	void multiply(int i, double value);
	void operator=(double value);
	void operator=(DoubleVector & v);
	void dump();
	
};

}

#endif /*DOUBLEVECTOR_H_*/

