/*
 * Copyright (C) 2009 Castrense Savojardo
 * 	Bologna Biocomputing Group
 * 	University of Bologna, Italy
 *  savojard@biocomp.unibo.it
 * 
 * This file is part of BioCRF
 * 
 * BioCRF is a free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 3 of the License,
 * or (at your option) any later version.
 *
 * BioCRF is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BioCRF; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 * 
 */
#ifndef GRAMMAREXCEPTION_H_
#define GRAMMAREXCEPTION_H_

namespace grammar {
	
class GrammarException
{
public:
	GrammarException();
	virtual ~GrammarException();
	virtual void report();
};

class GrammarNumberOfStatesException : public GrammarException
{ 
public:
	GrammarNumberOfStatesException();
	virtual ~GrammarNumberOfStatesException();
	void report();
};

class GrammarLabelsException : public GrammarException
{ 
public:
	GrammarLabelsException();
	virtual ~GrammarLabelsException();
	void report();
};

class GrammarLabelMappingSectionException : public GrammarException
{ 
public:
	GrammarLabelMappingSectionException();
	virtual ~GrammarLabelMappingSectionException();
	void report();
};

class GrammarStateMappingSectionException : public GrammarException
{ 
public:
	GrammarStateMappingSectionException();
	virtual ~GrammarStateMappingSectionException();
	void report();
};

class GrammarStateTransitionsSectionException : public GrammarException
{ 
public:
	GrammarStateTransitionsSectionException();
	virtual ~GrammarStateTransitionsSectionException();
	void report();
};
}
#endif /*GRAMMAREXCEPTION_H_*/

