/*
 * Copyright (C) 2009 Castrense Savojardo
 * 	Bologna Biocomputing Group
 * 	University of Bologna, Italy
 *  savojard@biocomp.unibo.it
 * 
 * This file is part of BioCRF
 * 
 * BioCRF is a free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 3 of the License,
 * or (at your option) any later version.
 *
 * BioCRF is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BioCRF; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 * 
 */
#ifndef MODEL_H_
#define MODEL_H_
#include "Transducer.h"
#include "Data.h"
#include "FeatureSet.h"
#include "Trainer.h"
#include "Decoder.h"
#include "Options.h"
#include "Optimizer.h"

namespace models
{

class Model
{
public:
	
	options::Options * options;
	grammar::Transducer * transducer;
	data::Data * data;
	training::Trainer * trainer;
	decoding::Decoder * decoder;
	features::FeatureSet * featureset;

	Model();
	Model(options::Options * options);
	~Model();
	
	virtual void train() {
	}
	
	virtual void decode() {
	}
	
	virtual training::Optimizer * get_optimizer() {
	}	
	
	virtual void dump() {
	}

	virtual void write_predictions() {
	}
};

}

#endif /*MODEL_H_*/

