/*
 * Copyright (C) 2009 Castrense Savojardo
 * 	Bologna Biocomputing Group
 * 	University of Bologna, Italy
 *  savojard@biocomp.unibo.it
 * 
 * This file is part of BioCRF
 * 
 * BioCRF is a free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 3 of the License,
 * or (at your option) any later version.
 *
 * BioCRF is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BioCRF; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 * 
 */
#ifndef OPTIMIZERLBFGS_H_
#define OPTIMIZERLBFGS_H_
#include "Optimizer.h"

namespace training
{

class OptimizerLBFGS : public Optimizer
{
public:
	int iflag;
	int diagco;
	double xtol;
	
	double * ws;
	double * diag;
	int * iprint;
	
	int mhessian;
	double epsilon;

	OptimizerLBFGS(int num_params, int mhessian, double epsilon);
	~OptimizerLBFGS(){
		if (iprint != NULL)
			delete [] iprint;
		if (diag != NULL)
			delete [] diag;
		if (ws != NULL)
			delete [] ws;
		
	}
	
	int optimize();
};

}

#endif /*OPTIMIZERLBFGS_H_*/

