/*
 * Copyright (C) 2009 Castrense Savojardo
 * 	Bologna Biocomputing Group
 * 	University of Bologna, Italy
 *  savojard@biocomp.unibo.it
 * 
 * This file is part of BioCRF
 * 
 * BioCRF is a free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 3 of the License,
 * or (at your option) any later version.
 *
 * BioCRF is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BioCRF; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 * 
 */
#ifndef OPTIONS_H_
#define OPTIONS_H_
#include <string>

#define BUFF_SIZE_LONG 20000

#define LCRFM 0
#define GRCRFM 1

#define DG 0

#define VITERBI 0
#define POSTERIORMAX 1
#define POSTERIORSUM 2

#define LBFGS 0

namespace options {

class Options
{
public:
	
	std::string training_file;
	std::string testing_file;
	std::string unlabelled_file;
	std::string topology_file;
	std::string cv_file;
	std::string test_session_file;
	
	std::string model_file;
	std::string train_logfile;
	std::string decode_logfile;
	std::string posterior_out_file;
	std::string prediction_file;
	
	int model;
	
	int window_size;
	
	int training_algorithm;
		
	int decoding_algorithm;
	bool include_bos_feature;
	bool include_eos_feature;

	bool istraining;
	bool istesting;
	bool ispredicting;
	bool isretraining;
	bool out_posterior;
	
	int iterations;
	double init_params_value;
	bool randomize_params;
	bool regularize;
	double sigma_square;
	
	double epsilon;
	int mhessian;
	
	bool is_scaling;

	int optimizer;
	
	Options();
	Options(std::string options_file);
	virtual ~Options();
	void read(std::string options_file);
	void dump();
};

}
#endif /*OPTIONS_H_*/

