/*
 * Copyright (C) 2009 Castrense Savojardo
 * 	Bologna Biocomputing Group
 * 	University of Bologna, Italy
 *  savojard@biocomp.unibo.it
 * 
 * MathlibException.cpp - This file is part of BioCRF
 * 
 * BioCRF is a free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 3 of the License,
 * or (at your option) any later version.
 *
 * BioCRF is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BioCRF; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 * 
 */
#include <iostream>
#include <stdlib.h>
#include "MathlibException.h"

namespace mathlib {

MathlibException::MathlibException()
{
}

MathlibException::~MathlibException()
{
}

void MathlibException::report()
{
	std::cout << "Exception in mathlib. Exit." << std::endl;
	exit(EXIT_FAILURE);
}

MathlibIncompatibleSizeException::MathlibIncompatibleSizeException(std::string classname)
{
	this->classname = classname;
}
MathlibIncompatibleSizeException::~MathlibIncompatibleSizeException()
{
}

void MathlibIncompatibleSizeException::report() 
{
	std::cout << "Incompatible size exception in "<< classname <<"." << std::endl;
	exit(EXIT_FAILURE);
}

MathlibIndexOutOfRangeException::MathlibIndexOutOfRangeException(std::string classname)
{
	this->classname = classname;
}

MathlibIndexOutOfRangeException::~MathlibIndexOutOfRangeException()
{
	
}

void MathlibIndexOutOfRangeException::report() 
{
	std::cout << "Index out of range exception in "<< classname << "." << std::endl;
	exit(EXIT_FAILURE);
}

MathlibNoValidSizeException::MathlibNoValidSizeException(std::string classname)
{
	this->classname = classname;
}

MathlibNoValidSizeException::~MathlibNoValidSizeException()
{
	
}

void MathlibNoValidSizeException::report() 
{
	std::cout << "No valid size exception in "<< classname << "." << std::endl;
	exit(EXIT_FAILURE);
}
}
