/*
 * Copyright (C) 2009 Castrense Savojardo
 * 	Bologna Biocomputing Group
 * 	University of Bologna, Italy
 *  savojard@biocomp.unibo.it
 * 
 * Feature.cpp - This file is part of BioCRF
 * 
 * BioCRF is a free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 3 of the License,
 * or (at your option) any later version.
 *
 * BioCRF is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BioCRF; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 * 
 */
#include "Feature.h"
#include "Conversions.h"

namespace features {
Feature::Feature(int to_state, int window_offset, int cp) {
		this->to_state = to_state;
		this->from_state = -1;
		this->window_offset = window_offset;
		this->cp = cp;
		this->weight = 0.0;
		this->type = STATE_FEATURE;
}

Feature::Feature(int to_state, int from_state)
{
		this->to_state = to_state;
		this->from_state = from_state;
		this->window_offset = 0;
		this->cp = -1;
		this->weight = 0.0;
		this->type = TRANS_FEATURE;
}

Feature::~Feature() {
}
}
